/* Interface file for Gandreas Music System Developer Kit */
/*  Call this first, if it returns true, then music playing is possible  */
pascal Boolean GMSInit();

/*  Call this to temporarily stop playback of the current music.  Should  */
/*  be called on suspend events  */
pascal void GMSPause();

/*  Call this to resume playback of the current music.  Call on resume  */
/*  events  */
pascal void GMSResume();

/*  This will clean up everything, release components, etc...  */
pascal void GMSQuit();

/*  This is the actual routine to play a 'Musi' resource generated from  */
/*  Midi2Musi.  It will lock it down for you - don't unlock or release  */
/*  the resource until you are done playing.  If you want to stop playing  */
/*  the current music and not play anything, pass NIL in  */
pascal void GMSPlay (Handle h);

/*  Call this routine during your idle proc - it checks to see if the  */
/*  music is done playing, and if so, causes it to repeat (don't call  */
/*  this if you don't want your background music to repeat)  */
pascal void GMSIdle();
