unit MungeCommon;

interface

	const
		csMountImage = 666;						(* only file_to_mount field in PB *)
		(* 667 was used in pre-release version *)
		csMountImageWithProgress = 668;

	type
		formatDesc = record		(* don't ask us what it means or we'll start to whimper *)
				capacity: longint;
				stuff: longint;
			end;

	const
		mf_read_write = 0;					(* bits in the mount_flags *)
		mf_read_write_mask = 1;		(* masks for same *)

	type
		mungeParamBlockRec = record
				qLink: QElemPtr;
				qType: INTEGER;
				ioTrap: INTEGER;
				ioCmdAddr: Ptr;
				ioCompletion: ProcPtr;
				ioResult: OSErr;
				ioNamePtr: StringPtr;
				ioVRefNum: INTEGER;
				ioCRefNum: integer;
				csCode: integer;
				case integer of
					0: (
							file_to_mount: FSSpecPtr;
							mount_flags: longint;
							progress: ProcPtr;			(* function MyProgress(pb : mungeParamBlockPtr) : OSErr; *)
							refcon: longint;
							progress_done: Fract;
							spare: array[1..100] of signedByte
					);
					1: (
							ioMisc: Ptr;
							ioBuffer: Ptr;
							ioReqCount: LONGINT;
							ioActCount: LONGINT;
							ioPosMode: INTEGER;
							ioPosOffset: LONGINT
					);
					2: (
							format_count: integer;
							format_point: ^formatDesc;
					);
					3: (
							status_current_track: integer;
							status_flags: signedByte;			(* the following 4 bytes must be in order and immediately in front of dqel *)
							status_disk_in_place: signedByte;
							status_drive_installed: signedByte;
							status_number_of_sides: signedByte;
							status_dqel: DrvQEl;
					);
			end;
		mungeParamBlockPtr = ^mungeParamBlockRec;

implementation

end. (* MungeCommon *)